#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;


int L[100010], R[100010], a[100010], t[100010], l[100010], r[100010], x[100010], dp[100010];

pair<int, bool> dfs (int v, int i) {
    if (v == 0) {
        return {0, false};
    }
    pair<int, bool> p = dfs(L[v], i);
    pair<int, bool> q = dfs(R[v], i);
    if (p.second) {
        if (a[v] == -1) {
            return {p.first+1, true};
        } else {
            return {p.first, true};
        }
    } else if (q.second) {
        if (a[v] != 1) {
            return {p.first + 1 + q.first, true};
        } else {
            return {p.first + q.first, true};
        }
    } else {
        if (v == i) {
            if (a[i] == -1) {
                return {1, true};
            } else if (a[i] == 0) {
                return {p.first + 1, true};
            } else {
                return {p.first+q.first+1, true};
            }
        }
        return {p.first+q.first+1, false};
    }
}

int dfs1(int v, int sum) {
    if (v == 0) {
        return 0;
    }
    int p, q;
    if (a[v] == -1) {
        p = dfs1(L[v], sum+1);
    } else {
        p = dfs1(L[v], sum);
    }
    if (a[v] != 1) {
        q = dfs1(R[v], sum + p + 1);
    } else {
        q = dfs1(R[v], sum + p);
    }
    if (a[v] == -1) {
        dp[v] = sum+1;
    } else if (a[v] == 0) {
        dp[v] = sum+1+p;
    } else {
        dp[v] = sum+1+p+q;
    }
    return p+q+1;
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n, q;
    cin >> n >> q;
    for (int i = 1; i <= n; i++) {
        cin >> L[i] >> R[i];
        a[i] = -1;
    }
    int cnt = 0, f = 0, cnt1 = 0;
    for (int i = 0; i < q; i++) {
        cin >> t[i];
        if (t[i] == 1) {
            cnt1++;
            if (cnt > 0) {
                f=1;
            }
            cin >> l[i] >> r[i] >> x[i];
        } else {
            cnt++;
            cin >> x[i];
        }
    }
    if (cnt1 <= 10) {
        dfs1(1, 0);
        for (int i = 0; i < q; i++) {
            if (t[i] == 1) {
                for (int j = l[i]; j <= r[i]; j++) {
                    a[j] = x[i];
                }
                dfs1(1, 0);
            } else {
                cnt++;
                cout << dp[x[i]] << '\n';
            }
        }
        return 0;
    }
    if (f == 1) {
        for (int i = 0; i < q; i++) {
            if (t[i] == 1) {
                for (int j = l[i]; j <= r[i]; j++) {
                    a[j] = x[i];
                }
            } else {
                cout << dfs(1, x[i]).first << '\n';
            }
        }
    } else {
        cnt = 0;
        for (int i = 0; i < q; i++) {
            if (t[i] == 1) {
                for (int j = l[i]; j <= r[i]; j++) {
                    a[j] = x[i];
                }
            } else {
                if (cnt == 0) {
                    dfs1(1, 0);
                }
                cnt++;
                cout << dp[x[i]] << '\n';
            }
        }
    }
    return 0;
}